#include <dos.h>
#include <mem.h>
#include "heap.h"

extern hptr  HeapPtr;
extern struct  a_heap {
  uint   handle;
  ulong  size;
  hptr   ptr;
} *Heap;

static void Movmem(hptr from, hptr to, ulong bytes)
{
  uint   size2move;
  ulong  index,
         size_moved;

  for (size_moved=0; bytes>0;) {
    size2move = (bytes > 65200UL) ?65200U :(uint)bytes;

    if (from > to)
      index = size_moved;
    else
      index = bytes-size2move;

    movedata(FP_SEG(from+index), FP_OFF(from+index),
             FP_SEG(to+index), FP_OFF(to+index), size2move);
    size_moved += size2move;
    bytes -= size2move;
   }
}

uchar Hfree(uint handle)
{
  uint   i;
  ulong  HeapToMove,
         size_to_free;
  hptr   ptr_to_free;

  if (HeapInitialized) {
    --handle;                        /* Decrement handle for 0 based Heap[] */
    if (handle >= 0 && handle < HeapMaxHandles &&
        (ptr_to_free = Heap[handle].ptr) != NULL) {
      size_to_free = Heap[handle].size;

      for (i=0, HeapToMove=0; i<HeapMaxHandles; ++i)   /* Count all handles */
        if (Heap[i].ptr > ptr_to_free) {               /*  and sum the rest */
          HeapToMove += Heap[i].size;                  /*  of the heap to   */
          Heap[i].ptr -= size_to_free;                 /*  the right        */
         }
                                                     /* Move heap over      */
      Movmem(ptr_to_free+size_to_free, ptr_to_free, HeapToMove);

      memset(&Heap[handle], 0, 10);                  /* Clear the handle    */

      --*(uint *)&HeapUsedHandles;                   /* Update variables    */
      *(ulong *)&HeapUnused += size_to_free;
      *(ulong *)&HeapUsed -= size_to_free;

      HeapPtr -= size_to_free;                       /* Calc new avail. ptr */

      HeapError = 0;
      return(1);                                     /* Return success      */
     }
    else                                             /* Handle not found or */
      HeapError = ERR_HANDNOTFOUND;                  /*  handle not valid   */
   }
  else                                               /* Heap not initlzed.  */
    HeapError = ERR_NOTINIT;

  return(0);                                         /* Return failure      */
}
