#include <mem.h>
#include <alloc.h>
#include "heap.h"

/*  Local variables  */
struct  a_heap {
  uint   handle;
  ulong  size;
  hptr   ptr;
} *Heap=NULL;

hptr  HeapPtr=NULL;

/*  Global variables  */
const char  *HeapVersion = "2.0";
const uchar  HeapInitialized=0;
const uint   HeapMaxHandles=0,
             HeapUsedHandles=0;
const ulong  HeapUsed=0,
             HeapUnused=0;

uchar  HeapError=0;
hptr   HeapBase=NULL;

uchar InitHeap(uint handles, ulong bytes)
{
  uint  size;

  if (HeapInitialized) {
    HeapError = ERR_ALREADYINIT;
    return(0);
   }

  if (bytes) {
    if (handles <= 6000) {
      /* Allocate heap internal variables */
      size = (handles+1) * sizeof(struct a_heap);
      Heap = malloc(size);

      if (Heap != NULL) {
        /* Clear all heap internal variables */
        memset(Heap, 0, size);

        /* Allocate a heap */
        if ((HeapBase = (hptr)farmalloc(bytes)) != NULL) {
          /* Initialize variables */
          HeapPtr = HeapBase;
          *(ulong *)&HeapUnused = bytes;
          *(ulong *)&HeapUsed = 0;
          *(uint *)&HeapMaxHandles = handles;
          *(uint *)&HeapUsedHandles = 0;
          *(uchar *)&HeapInitialized = 1;
          HeapError = 0;
          return(1);
         }
        else {
          free(Heap);
          HeapError = ERR_SIZETOOLARGE;
         }
       }
      else
        HeapError = ERR_TOOMANYHAND;
     }
    else
      HeapError = ERR_TOOMANYHAND;
   }
  else
    HeapError = ERR_SIZETOOSMALL;

  Heap = NULL;                            /* Clear variables for an error */
  HeapBase = NULL;
  HeapPtr = NULL;
  *(ulong *)&HeapUnused = 0;
  *(ulong *)&HeapUsed = 0;
  *(uint *)&HeapMaxHandles = 0;
  *(uint *)&HeapUsedHandles = 0;
  *(uchar *)&HeapInitialized = 0;
  return(0);
}

void UnInitHeap(void)
{
  if (HeapInitialized) {
    /* Free heap variables & allocated heap */
    free(Heap);
    farfree((fptr)HeapBase);
  
    Heap = NULL;                            /* Clear variables */
    HeapBase = NULL;
    HeapPtr = NULL;
    *(ulong *)&HeapUnused = 0;
    *(ulong *)&HeapUsed = 0;
    *(uint *)&HeapMaxHandles = 0;
    *(uint *)&HeapUsedHandles = 0;
    *(uchar *)&HeapInitialized = 0;
    HeapError = 0;
   }
  else
    HeapError = ERR_NOTINIT;
}
